
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Audit_logsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.create(
            {
                id: data.id || undefined,
        
        action: data.action
        ||
        null
            ,
            
        module: data.module
        ||
        null
            ,
            
        entityId: data.entityId
        ||
        null
            ,
            
        entityType: data.entityType
        ||
        null
            ,
            
        oldValueJson: data.oldValueJson
        ||
        null
            ,
            
        newValueJson: data.newValueJson
        ||
        null
            ,
            
        ipAddress: data.ipAddress
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        eventAt: data.eventAt
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await audit_logs.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return audit_logs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const audit_logsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                action: item.action
            ||
            null
            ,
            
                module: item.module
            ||
            null
            ,
            
                entityId: item.entityId
            ||
            null
            ,
            
                entityType: item.entityType
            ||
            null
            ,
            
                oldValueJson: item.oldValueJson
            ||
            null
            ,
            
                newValueJson: item.newValueJson
            ||
            null
            ,
            
                ipAddress: item.ipAddress
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                eventAt: item.eventAt
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const audit_logs = await db.audit_logs.bulkCreate(audit_logsData, { transaction });

        // For each item created, replace relation files
        

        return audit_logs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const audit_logs = await db.audit_logs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.action !== undefined) updatePayload.action = data.action;
        
        
        if (data.module !== undefined) updatePayload.module = data.module;
        
        
        if (data.entityId !== undefined) updatePayload.entityId = data.entityId;
        
        
        if (data.entityType !== undefined) updatePayload.entityType = data.entityType;
        
        
        if (data.oldValueJson !== undefined) updatePayload.oldValueJson = data.oldValueJson;
        
        
        if (data.newValueJson !== undefined) updatePayload.newValueJson = data.newValueJson;
        
        
        if (data.ipAddress !== undefined) updatePayload.ipAddress = data.ipAddress;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.eventAt !== undefined) updatePayload.eventAt = data.eventAt;
        
        
        updatePayload.updatedById = currentUser.id;

        await audit_logs.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await audit_logs.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return audit_logs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of audit_logs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of audit_logs) {
                await record.destroy({transaction});
            }
        });


        return audit_logs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findByPk(id, options);

        await audit_logs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await audit_logs.destroy({
            transaction
        });

        return audit_logs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const audit_logs = await db.audit_logs.findOne(
            { where },
            { transaction },
        );

        if (!audit_logs) {
            return audit_logs;
        }

        const output = audit_logs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await audit_logs.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.module) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'module',
                        filter.module,
                    ),
                };
            }
            
            if (filter.entityId) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'entityId',
                        filter.entityId,
                    ),
                };
            }
            
            if (filter.entityType) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'entityType',
                        filter.entityType,
                    ),
                };
            }
            
            if (filter.oldValueJson) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'oldValueJson',
                        filter.oldValueJson,
                    ),
                };
            }
            
            if (filter.newValueJson) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'newValueJson',
                        filter.newValueJson,
                    ),
                };
            }
            
            if (filter.ipAddress) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'ipAddress',
                        filter.ipAddress,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_logs',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.eventAtRange) {
                const [start, end] = filter.eventAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    eventAt: {
                    ...where.eventAt,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    eventAt: {
                    ...where.eventAt,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.action) {
                where = {
                    ...where,
                action: filter.action,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.audit_logs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'audit_logs',
                        'module',
                        query,
                    ),
                ],
            };
        }

        const records = await db.audit_logs.findAll({
            attributes: [ 'id', 'module' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['module', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.module,
        }));
    }

    
};

